#include "main.h"
#include "motor.h"

float PID_err=0;
float PID_last_err =0;
float PID_kp = 0.01;
float PID_ki = 0.01;
float PID_pwm =0;

float speed_value;

unsigned int speed_target = 1500;
uchar counter_PID=0,PID_flag=0;

extern uchar motor_state;
extern uint counter_1s;

unsigned int adc_value =0;
unsigned char LVDT_counter =0;
void main() 
{
	GIE = 1;
	gpio_init();
	//while(1);
	t11_init(); 
	UARTInit();
	TIM13_init();
	ADCInit();
	
	//startMotor();
	while(1)
	{	

		/**************************Ƿѹ***************************/
		adc_value = ADCRead(3);  
		if(adc_value < LVDT_VALUE)
		{
			LVDT_counter++;
			if(LVDT_counter>=10)
			{
				LVDT_counter=10;
				motor_state = MOTOR_VPROTECT;
			}
		}
		else
		{
			LVDT_counter = 0;
			if(motor_state == MOTOR_VPROTECT )
				motor_state = MOTOR_STOP;
		}


		/**************************ٶ״̬UART***************************/
		speed_value = get_speed();
		if(counter_1s>=1000) //ÿ뷢һٶϢ
		{
			counter_1s == 0;
			uart_sendInit(speed_value);
		}

		/**************************״̬***************************/
		if(motor_state ==MOTOR_RUN )
			KMSK0=1;  //KINT0
		else 
			KMSK0=0;  //KINT0

		if(motor_state == MOTOR_START )
		{
			startMotor();
		}
		else if(motor_state ==MOTOR_STOP )
			stopMotor();
		else if(motor_state ==MOTOR_RUN )
		{
			if(PID_flag)
			{
				PID_flag =0;
				
				PID_err =speed_target - speed_value;
				PID_pwm =PID_pwm+PID_err*PID_kp+PID_ki*(PID_err-PID_last_err);						
				if(PID_pwm<=50)
					PID_pwm = 50;
				else if(PID_pwm>=990)
					PID_pwm =990;
				PID_last_err = PID_err;
				set_PWM_Duty((uint)PID_pwm);
			}
			
		}
		else if(motor_state ==MOTOR_CHANGEDIR)
		{
			stopMotor();
			dealy(1000);
			motor_state = MOTOR_START;
			startMotor();
		}
		else if(motor_state == MOTOR_VPROTECT)
		{
			stopMotor();
		}
		else if(motor_state == MOTOR_IPROTECT)
		{
			stopMotor();
		}
		
	}
}                         

void dealy(unsigned int t)
{
	int i,j;
	for(i=0;i<t;i++)
		for(j=0;j<=100;j++)
		{
		}
}



