#include "key.h"

void key_init(void)
{
	GPIO_InitSettingType x;
	KINT_InitSettingType y;	
	
	x.Func = GPIO_Reuse_Func0;
	x.Dir  = GPIO_Direction_Input;	
	x.PUE  = GPIO_PUE_Input_Enable;
	x.PDE  = GPIO_PDE_Input_Disable;
	x.DS   = GPIO_DS_Output_Normal;
	x.ODE  = GPIO_ODE_Output_Disable;
	x.Signal = GPIO_Pin_Signal_Digital;
	GPIO_Init(GPIO_Pin_A24, &x);
	GPIO_Init(GPIO_Pin_A25, &x);
	GPIO_Init(GPIO_Pin_A26, &x);
	GPIO_Init(GPIO_Pin_A27, &x);
	
	y.IE_Set = KINT_IE_Set_Enable;
	y.Trigger_Style = KINT_Trigger_Trailing_Edge;
	KINT_Init(GPIO_Pin_A24, &y);	
	KINT_Init(GPIO_Pin_A25, &y);
	KINT_Init(GPIO_Pin_A26, &y);
	KINT_Init(GPIO_Pin_A27, &y);
}
