#include "motor.h"

#define SPEED_FILTER_NUM 5
int pwm_duty=0;
uchar motor_state=MOTOR_STOP;
uchar MotorDir = 0;
uchar stop_flag = 0;


uint counter13=0,counter13_record = 0;
uchar T13H_record=0,T13L_record;

unsigned long speed_count[SPEED_FILTER_NUM];
unsigned char i_store=0;
extern uchar counter_PID,PID_flag;
extern unsigned int speed_target;
uint counter_1s=0;
void gpio_init(void)
{
    ANSL = 0Xff;  //PA345ΪģȽ˿
    ANSH = 0XFF;
	/*************** PA4 AN3 Ϊģ˿ ͵ѹ********************/
	ANSL3 = 0;  

	/********************** LED IR2136ʹ*****************************/
	PAT0 = 0;  //ɫLED
	PA0 = 0;  
	PAT1 = 0;  //ɫLED
	PA1 = 0;
	PAT3 = 0;  //IR2136ʹ
	PA3 = 1;
	/**********************˿*****************************/
	PBT4 = 1;  
	PBPU4 =1;
	KIE = 1;  //ʹKINT
	KMSK0=0;  //KINT 0
	KMSK1=0;
	KMSK2=0;
	KMSK3=0;
	/**********************HALL*****************************/
	PBT5 = 1;  //HALL u
	PBT6 = 1;  //HALL v
	PBT7 = 1;  //HALL w
	PEG21 = 1;
	PEG20 = 1; //˫شPINT234
	PIE2 = 0;
	PIE3 = 0;
	PIE4 = 0; //ֹⲿж
	PIF2 = 0;
	PIF3 = 0;
	PIF4 = 0; //ⲿжϱ־

	PHASE_U_H = 1;			//PINʼ
	PHASE_U_H_Dir = 0;
	PHASE_U_L = 1;
	PHASE_U_L_Dir = 0;
	PHASE_V_H = 1;
	PHASE_V_H_Dir = 0;
	PHASE_V_L = 1;
	PHASE_V_L_Dir = 0;
	PHASE_W_H = 1;
	PHASE_W_H_Dir = 0;
	PHASE_W_L = 1;
	PHASE_W_L_Dir = 0;

}


/**************************************************************************
*    void InitWDT(void)   
*  ÿŹ        
*                                  
*ֵ                   
*ú  
*  ʼ֮ǰһ
*޶Ҫ  2014.08.04                        
**************************************************************************/
uint8  startMotor(void)
{
	uint16 i = 0,motot_step=1;
	uint32 delayMs1 = 5000;	
	PIE2 = 1;
	PIE3 = 1;
	PIE4 = 1;
	
	while(motor_state == MOTOR_START)
	{
		set_PWM_Duty(motot_step*100);
		change_step();
		for(i=0;i<delayMs1;i++)
		{
			NOP();
		}
		motot_step++;
		if(motot_step>=10)
			return FALSE;
	}
	//set_PWM_Duty(800);
	//T13EN = 1;
	return SUCCESS;
	 
}

void change_step_I(void)
{
	uchar CapState=0;
	CapState = (uchar)PB5|(uchar)PB6<<1|(uchar)PB7<<2;
	if(MotorDir == 0)
		switch(CapState)
		{

			case 1:phase_change_H_I(1);break;
			case 2:phase_change_H_I(3);break;
			case 3:phase_change_H_I(2);break;
			case 4:phase_change_H_I(5);break;
			case 5:phase_change_H_I(0);break;
			case 6:
				phase_change_H_I(4);
				stop_flag = 0;
				//T13EN=0;
				T13H_record = T13H;
				T13L_record = T13L;

				speed_count[i_store++] = (counter13*1000)+T13L_record+((uint)T13H_record<<8);
				if(i_store>=SPEED_FILTER_NUM)
					i_store=0;
				T13L = 0;
				T13H =0;
				counter13 = 0;
				//T13EN = 1;
				break;
			default:break;
		}
	else
		switch(CapState)
		{
			case 6:phase_change_H_I(1);break;
			case 5:phase_change_H_I(3);break;
			case 4:phase_change_H_I(2);break;
			case 3:phase_change_H_I(5);break;
			case 2:phase_change_H_I(0);break;
			case 1:phase_change_H_I(4);
				phase_change_H_I(4);
				stop_flag = 0;
				//T13EN=0;
				T13H_record = T13H;
				T13L_record = T13L;

				speed_count[i_store++] = (counter13*1000)+T13L_record+((uint)T13H_record<<8);
				if(i_store>=SPEED_FILTER_NUM)
					i_store=0;
				T13L = 0;
				T13H =0;
				counter13 = 0;
				//T13EN = 1;
			break;
			default:break;
		}
}
void change_step(void)
{
	uchar CapState=0;
	CapState = (uchar)PB5|(uchar)PB6<<1|(uchar)PB7<<2;
	if(MotorDir == 0)
		switch(CapState)
		{

			case 1:phase_change_H(1);break;
			case 2:phase_change_H(3);break;
			case 3:phase_change_H(2);break;
			case 4:phase_change_H(5);break;
			case 5:phase_change_H(0);break;
			case 6:phase_change_H(4);break;
			default:break;
		}
	else
		switch(CapState)
		{
			case 6:phase_change_H(1);break;
			case 5:phase_change_H(3);break;
			case 4:phase_change_H(2);break;
			case 3:phase_change_H(5);break;
			case 2:phase_change_H(0);break;
			case 1:phase_change_H(4);break;
			default:break;
		}
}


float get_speed(void)
{
		float speedw;
		unsigned long sum=0;
		unsigned char i=0,j=0;
		if(stop_flag == 1)
			return 0;
		for(i=0;i<SPEED_FILTER_NUM;i++)
		{
			if((speed_count[i]>6000) && (speed_count[i]<100000))
			{
				j++;
				sum+=speed_count[i];
			}
		}
		if(j<SPEED_FILTER_NUM/2)
		{
			speedw = 0;
			return 0;
		}
		sum = sum/j;
		speedw = (30000000.0/(float)sum);
		return speedw;
}


void isr(void) interrupt
{
	unsigned char Rx_value =0;
	unsigned char temp_pb4 =0;
	if(PIE2 && PIF2)   //u
	{ 	   		
		PIF2 = 0;	
		change_step_I();
		if(motor_state == MOTOR_START)
			motor_state = MOTOR_RUN;
	}
	else if(PIE3 && PIF3)  //v
	{
		PIF3  = 0;
		change_step_I();
		if(motor_state == MOTOR_START)
			motor_state = MOTOR_RUN;
	}
	else if(PIE4 && PIF4)  //w
	{
		PIF4  = 0;
		change_step_I();
		if(motor_state == MOTOR_START)
			motor_state = MOTOR_RUN;
		
			
	}
	else if(T13IE && T13IF)
	{
		T13IF =0;
		counter13++;
		counter_PID++;
		counter_1s++;
		if(counter13 >=200) //0.2
		{
			counter13 =0;
			stop_flag = 1;
		}
		if(counter_PID>=10) //10msһPID
		{
			PID_flag = 1;
			counter_PID =0;
		}

	}
	else if(RXIF && RXIE)
	{
		RXIF = 0;
		Rx_value = RXB;
		//TXB = Rx_value;
		//while(!TRMT);
		if(Rx_value<=100)
		{
			speed_target = Rx_value*40;
			if(speed_target<800)
				speed_target =800;
		}
		else if((Rx_value == UART_POSI_FLAG)&&(motor_state != MOTOR_VPROTECT)&&(motor_state != MOTOR_IPROTECT)) 
		{
			if(MotorDir == 0)
			{
				motor_state = MOTOR_CHANGEDIR;
				MotorDir = 1;
			}
		}
		else if((Rx_value == UART_MEG_FLAG)&&(motor_state != MOTOR_VPROTECT)&&(motor_state != MOTOR_IPROTECT) )
		{
			if(MotorDir == 1)
			{
				motor_state=MOTOR_CHANGEDIR;
				MotorDir = 0;
			}
		}
		else if((Rx_value == UART_STOP_FLAG)&&(motor_state != MOTOR_VPROTECT)&&(motor_state != MOTOR_IPROTECT)  )
			motor_state=MOTOR_STOP;
		else if((Rx_value == UART_START_FLAG) && ((motor_state == MOTOR_STOP)||(motor_state == MOTOR_IPROTECT)))
			motor_state=MOTOR_START;
	}

	else if(KIE && KIF)
	{
		temp_pb4 = PB4;
		KIF = 0;
	    //motor_state = MOTOR_IPROTECT;
	}
}