#include <hic.h>

#ifndef _PWM_H
#define _PWM_H

#include "typedef.h"

#define  PHASE_U_H PA6
#define  PHASE_U_L PB3
#define  PHASE_V_H PA7
#define  PHASE_V_L PB2
#define  PHASE_W_H PB0
#define  PHASE_W_L PB1

#define  PHASE_U_H_Dir PAT6
#define  PHASE_U_L_Dir PBT3
#define  PHASE_V_H_Dir PAT7
#define  PHASE_V_L_Dir PBT2
#define  PHASE_W_H_Dir PBT0
#define  PHASE_W_L_Dir PBT1 

#define OPEN_PHASE_U_H_PWM	T12OC = 0X44
#define CLOSE_PHASE_U_H_PWM T12OC = 0X40
#define OPEN_PHASE_V_H_PWM  PWM30EN = 1
#define CLOSE_PHASE_V_H_PWM PWM30EN = 0
#define OPEN_PHASE_W_H_PWM  T11OC = 0X05
#define CLOSE_PHASE_W_H_PWM T11OC = 0X00

//#define PWM_FREQ ((unsigned int)16000)
//#define CKTIM ((unsigned int)16000000)
//#define PWM_PERIOD ((unsigned int)((CKTIM)/(PWM_FREQ)))
#define PWM_PERIOD 1000   //ƵΪ16K
#define PWM_START 500
#define PWM_RUN   500


void t11_init(void);
void stopMotor(void);
void phase_change_H(uint );
void phase_change_H_I(uint);
void set_PWM_Duty(unsigned int dutyData);
#endif
