#include "pwm.h"


void t11_init(void)
{
	T11C = 0x80;
	T11CH = 0x10;   //T11ΪPWMģʽʹ÷Ƶ2  11  16Mʱ ʱʱΪ16M
	T11OC = 0x00;   

	T12OC = 0x40;
	T13OC = 0x40;    //pwm20pwm30ʹT11ʱ

	PWM1M0 = 1;   //ѡ񣬵Ч
	PWM1M1 = 1;
	PWM2M0 = 1;
	PWM2M1 = 1;
	PWM3M0 = 1;
	PWM3M1 = 1;
	T11PL = PWM_PERIOD%256;  //ƵΪ8K
	T11PH = PWM_PERIOD/256;

	set_PWM_Duty(500);
	T11EN =1;
}

void set_PWM_Duty(unsigned int dutyData)
{
	if(dutyData>=PWM_PERIOD)
		dutyData = PWM_PERIOD;
	T11RL = dutyData%256;
	T11PH &=0x0f;
	T11PH |= dutyData/256<<4;
}

/**************************************************************************
*    void stopMotor(void)   
*  л      
*                                 
*ֵ                   
*ú  
*  رյʱ
*޶Ҫ  2015.04.13                        
**************************************************************************/
void stopMotor(void)
{
	ACP2IE = 0;
	ACP3IE = 0;
	ACP5IE = 0;
	CLOSE_PHASE_U_H_PWM;
	CLOSE_PHASE_V_H_PWM;
	CLOSE_PHASE_W_H_PWM;

	PHASE_U_L = 1;
	PHASE_U_H = 1;
	PHASE_V_L = 1;
	PHASE_V_H = 1;
	PHASE_W_L = 1;
	PHASE_W_H = 1;
}
/**************************************************************************
*    void phase_change(void)   
*  л      
*                                 
*ֵ                   
*ú  stopMotor,ź
*  ʱ
*޶Ҫ  2015.04.13                        
**************************************************************************/
void phase_change_H(uint MotorPhase)
{
	//stopMotor();//ΪԺתܼݣPINţٸл
	
		switch(MotorPhase)
		{
			case 0:   //U->V
				PHASE_U_L = 1;//UűNMOSرգűNMOS PWM
				OPEN_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_H = 1;//VűNMOS رգűNMOS
				PHASE_V_L = 0;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 1;

				break;
			case 1: //U->W
				PHASE_U_L = 1;
				OPEN_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_H = 1;
				PHASE_V_L = 1;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 0;	

				break;
			case 2: //V->W
				PHASE_U_L = 1;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				OPEN_PHASE_V_H_PWM;
				PHASE_V_L = 1;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 0;	

				break;
			case 3://V->U
				PHASE_U_L = 0;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				OPEN_PHASE_V_H_PWM;
				PHASE_V_L = 1;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 1;	

				break;
			case 4: //W->U
				PHASE_U_L = 0;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_L = 1;
				PHASE_V_H = 1;

				OPEN_PHASE_W_H_PWM;
				PHASE_W_L = 1;	

				break;
			case 5: //W-V
				PHASE_U_L = 1;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_L = 0;
				PHASE_V_H = 1;

				OPEN_PHASE_W_H_PWM;
				PHASE_W_L = 1;	

				break;		
			default:
				stopMotor();
				break;
		}
	
}


void phase_change_H_I(uint MotorPhase)
{
	
		switch(MotorPhase)
		{
			case 0:   //U->V
				PHASE_U_L = 1;//UűNMOSرգűNMOS PWM
				OPEN_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_H = 1;//VűNMOS رգűNMOS
				PHASE_V_L = 0;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 1;

				break;
			case 1: //U->W
				PHASE_U_L = 1;
				OPEN_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_H = 1;
				PHASE_V_L = 1;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 0;	

				break;
			case 2: //V->W
				PHASE_U_L = 1;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				OPEN_PHASE_V_H_PWM;
				PHASE_V_L = 1;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 0;	

				break;
			case 3://V->U
				PHASE_U_L = 0;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				OPEN_PHASE_V_H_PWM;
				PHASE_V_L = 1;

				CLOSE_PHASE_W_H_PWM;
				PHASE_W_H = 1;
				PHASE_W_L = 1;	

				break;
			case 4: //W->U
				PHASE_U_L = 0;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_L = 1;
				PHASE_V_H = 1;

				OPEN_PHASE_W_H_PWM;
				PHASE_W_L = 1;	

				break;
			case 5: //W-V
				PHASE_U_L = 1;
				PHASE_U_H = 1;
				CLOSE_PHASE_U_H_PWM;

				CLOSE_PHASE_V_H_PWM;
				PHASE_V_L = 0;
				PHASE_V_H = 1;

				OPEN_PHASE_W_H_PWM;
				PHASE_W_L = 1;	

				break;		
			default:
				//stopMotor();
				break;
		}
	
}